var util = require('../../../utils/util.js'); 
var api = require('../../../config/api.js'); 

Page({

  /**
   * 页面的初始数据
   */
  data: {
    imgUrl:''

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  }, 

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that=this
    util.request(api.RefereePoster, {}, 'POST').then(function (res) {
      that.setData({
        imgUrl:res.data.imgUrl
      }) 
    });  
  },
  
  goSaveQrcode:function(){//保存二维码图片
    let that=this;
    console.info(that.data.myqr_url);
    wx.downloadFile({
      url: that.data.imgUrl,
      success:function(res){
        if(res.statusCode===200){
          let img=res.tempFilePath;
          wx.saveImageToPhotosAlbum({
            filePath: img,
            success(res){ 
              wx.showToast({
                title: '保存成功'
            })
            },
            fail(res){ 
              util.showErrorToast('图片保存失败 请重试');
            }
          })
        } 
      },
      fail(res){  
        util.showErrorToast('图片保存失败 请重试');
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})